/* Arexx */

options results

/*
    Okay, this little script will bevel and then make proper smoothing
    objects out of your original object.
    
    To get it to work properly, you must supply an object. 
    This object must be flat, lie on the X,Y plane and be
    filled with faces. The object should also be fairly large.

    Load your object, ensure the proper restrictions are met (flat object,
    face filled, etc.) and then lauch the script by using the
    Modify-Macro command. From the file requester, select this macro.

*/

'select all'                /* Select All the vertices in memory */
'name Slice-2'              /* We temporarily name the object all the */
                            /* same. */

'getv BEVEL_INSET 10'
ins=result
'getv BEVEL_DEPTH -10'
dep=result


'bevel' ins dep             /* If your beveling looks bad for this object */
                            /* then change these numbers. At normal       */
                            /* resolution, ie Zoom 1, my objects usually  */
                            /* fill the whole screen or are bigger than   */
                            /* the screen */

'name Slice-1'              /* After beveling, the newly created points   */
                            /* will be selected, and the originals will   */
                            /* deselected. We take advantage of this and  */
                            /* name them. This will eventually be a flat  */
                            /* object since we don't want it to smoothed  */

'select swap'               /* Now, swap select to get the original points*/
'extrude 0 0 20 0 0 0 1 1 1 1'
'name Slice-3'              /* After extruding them we name these to keep */
                            /* them seperate from the other points */

'deselect all'              /* Now, deselect everything */
'select name Slice-2'       /* Select the original set of points */
'delete internal'           /* so we can delete the internal faces */
                            /* which will never get rendered and we don't */
                            /* need */

'deselect all'

'select name Slice-1'       /* Select the points to make the Front_Plate */
'separate'                  /* We seperate these and name them */
'name Front_Plate'          /* We now have a seperate object   */
                            /* which will be flat */

'deselect all'
'Select name Slice-3'       /* Ditto for the Back_Plate */
'separate'
'name Back_Plate'

'deselect all'              /* Now create the beveled_edge object */
'Select name Slice-1'       /* These are the points made from the bevel */
'Select name Slice-2'       /* These are the original object points */
'duplicate 0 0 0 0 0 0 1 1 1 1'
'name Beveled_Edge'         /* Dupicate them and call them Beveled_Edge */
'deselect all'
'select name Slice-1'       /* We no longer need these vertices */
'delete vertices'

'deselect all'              /* Now it just remains to select the remaining */
'select name Back_Plate'    /* points and call them Smooth_Sides */
'select Name Front_Plate'   /* We do this indirectly by selecting all */
'Select Name Beveled_Edge'  /* the other points and swap selecting */
'Select Swap'
'Name Smooth_Sides'

'draw'
'endd'
